; v.2008-10-20

.386
.model flat,stdcall
option casemap:none

; ml   /I\masm32\include ...
; link /libpath:\masm32\lib ...

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib user32
inclib kernel32
inclib gdi32
inclib comctl32
inclib _cbt_hook_dll

.const
 id        equ 100
 
.data
 _app       db " CBT hook    //    HCBT_CREATEWND   &   GA_PARENT",0
 _listbox   db "ListBox",0
 _32774     db "#32774",0 
 _0         db " movesize  ",0
 _1         db " minmax    ",0
 _2         db " qs            <%4.4lX>     (%lX)         (%lX)",0
 _3         db " CREATEWND*",0
 _4         db " destroywnd",0 
 _5         db " activate* ",0
 _6         db " clickskipped  <%4.4lX>   wm(%4.4lX)  hwnd(%8.8lX)  ht(%d)",0
 _7         db " keyskipped    <%4.4lX>   vk(%4.4lX)  code(%8.8lX)",0
 _8         db " syscommand    <%4.4lX>   sc(%4.4lX)  lprm(%8.8lX)  xy(%d,%d)",0
 _9         db " setfocus  ",0
 _isnt      db "   ........  ........  ........  ....",0 
 _head      db " HCBT_        param      Parent    Owner     Window    Id    Pid       Tid       Class",0
 _hk        db "%s%11.8lX%11.8lX%10.8lX%10.8lX%6.4lX%10.8lX%10.8lX  %s",0
 _rep       db "%s%s%s",0
 _XXXX      db "%11.8lX%10.8lX%10.8lX%6.4lX",0
 _Xs        db "%9.8lX     %s",0
 _dsk       db "%8.8lX    #32769     HWND_DESKTOP",0
 _msg       db "%8.8lX    Message    HWND_MESSAGE",0
 _74        db "%8.8lX    #32774     (message-only)",0 
 _send      db "[send]",0
 _post      db "[post]",0
 _senddl    db "[send+delay]",0
 _ontop     db "OnTop",0
 _nontop    db "NonTop",0
 _hook      db "HOOK",0
 _unhook    db "UnHOOK",0
 _z         db 0 
 hookflag   dd 0
 postparam  dd 0
 count_sys  dd 0
 count_qs   dd 0
 count_clk  dd 0
 count_key  dd 0
 hinst      dd 0
 _logfont   LOGFONT <-11,0,0,0,400,0,0,0,1,0,0,0,0,"Courier New">
 
.data?
.code

;##########################################################################################

WndProc proc uses ebx edi esi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  local buffe[256]:BYTE, buff[128]:BYTE, buf[128]:BYTE, bu[64]:BYTE, pid:DWORD, pt:POINT
  
  xor eax,eax
  mov byte ptr [buffe],al
  mov byte ptr [buff],al
  mov byte ptr [buf],al
  mov byte ptr [bu],al
  mov pid,eax
  mov edx,wParam
  mov eax,uMsg
;------------------------------------------------------------------------------------------
  .if eax==WM_DESTROY

    .if hookflag!=0
      invoke UninstallHook
    .endif
    invoke PostQuitMessage,0
    xor eax,eax
;------------------------------------------------------------------------------------------
  .elseif (eax==WM_APP+HCBT_DESTROYWND || eax==WM_APP+HCBT_CREATEWND || eax==WM_APP+HCBT_ACTIVATE || eax==WM_APP+HCBT_SETFOCUS || eax==WM_APP+HCBT_MINMAX || eax==WM_APP+HCBT_MOVESIZE) && edx!=hWnd

    sub eax,WM_APP
    .if eax==HCBT_CREATEWND
      mov edi,offset _3
    .elseif eax==HCBT_DESTROYWND
      mov edi,offset _4
    .elseif eax==HCBT_MOVESIZE
      mov edi,offset _0
    .elseif eax==HCBT_MINMAX
      mov edi,offset _1
    .elseif eax==HCBT_ACTIVATE
      mov edi,offset _5
    .elseif eax==HCBT_SETFOCUS
      mov edi,offset _9
    .endif
    invoke GetWindowThreadProcessId,wParam,addr pid
    mov ebx,eax
    invoke GetClassName,wParam,addr buff,127
    invoke GetWindowLong,wParam,GWL_ID
    and eax,0ffffh
    push eax
    invoke GetWindow,wParam,GW_OWNER
    mov esi,eax
    invoke GetAncestor,wParam,GA_PARENT
    mov ecx,eax
    pop edx
    invoke wsprintf,addr buffe,offset _hk,edi,lParam,ecx,esi,wParam,edx,pid,ebx,addr buff
    invoke SendMessage,hWnd,LB_ADDSTRING,0,addr buffe
    invoke SendMessage,hWnd,LB_SETITEMDATA,eax,wParam
    xor eax,eax
;------------------------------------------------------------------------------------------
  .elseif eax==WM_APP+HCBT_QS

    inc count_qs
    invoke wsprintf,addr buf,offset _2,count_qs,wParam,lParam    
    invoke SendMessage,hWnd,LB_DELETESTRING,1,0    
    invoke SendMessage,hWnd,LB_INSERTSTRING,1,addr buf
     xor eax,eax   
;------------------------------------------------------------------------------------------
  .elseif eax==WM_APP+HCBT_SYSCOMMAND
  
    inc count_sys
    mov ecx,lParam
    mov edx,ecx
    and ecx,0ffffh
    shr edx,16
    invoke wsprintf,addr buf,offset _8,count_sys,wParam,lParam,ecx,edx
    invoke SendMessage,hWnd,LB_DELETESTRING,2,0
    invoke SendMessage,hWnd,LB_INSERTSTRING,2,addr buf
    xor eax,eax
;------------------------------------------------------------------------------------------
  .elseif eax==WM_APP+HCBT_KEYSKIPPED
    
    inc count_key
    invoke wsprintf,addr buf,offset _7,count_key,wParam,lParam    
    invoke SendMessage,hWnd,LB_DELETESTRING,3,0    
    invoke SendMessage,hWnd,LB_INSERTSTRING,3,addr buf    
    xor eax,eax    
;------------------------------------------------------------------------------------------
  .elseif eax==WM_APP+HCBT_CLICKSKIPPED
    
    inc count_clk
    mov ecx,wParam
    mov edx,ecx
    and ecx,0ffffh
    shr edx,16
    invoke wsprintf,addr buf,offset _6,count_clk,ecx,lParam,edx
    invoke SendMessage,hWnd,LB_DELETESTRING,4,0    
    invoke SendMessage,hWnd,LB_INSERTSTRING,4,addr buf
    invoke SendMessage,hWnd,LB_SETITEMDATA,4,lParam
    xor eax,eax    
;------------------------------------------------------------------------------------------
  .elseif eax==WM_COMMAND && lParam==0

    .if wParam==id+1  ; (Clear)
    
      invoke GetMenu,hWnd
      mov ebx,eax
;      invoke FindWindowEx,HWND_DESKTOP,0,0,0
;      invoke GetAncestor,eax,GA_PARENT
      invoke GetDesktopWindow
      mov edi,eax
      invoke wsprintf,addr buf,offset _dsk,eax
      invoke ModifyMenu,ebx,id+10,MF_BYCOMMAND or MF_STRING,id+10,addr buf
;      invoke FindWindowEx,HWND_MESSAGE,0,0,0
      invoke FindWindowEx,HWND_MESSAGE,0,offset _32774,0
      mov esi,eax
      invoke wsprintf,addr buf,offset _74,eax      
      invoke ModifyMenu,ebx,id+12,MF_BYCOMMAND or MF_STRING,id+12,addr buf
      invoke GetAncestor,esi,GA_PARENT
      push eax
      invoke wsprintf,addr buf,offset _msg,eax
      invoke ModifyMenu,ebx,id+11,MF_BYCOMMAND or MF_STRING,id+11,addr buf
      pop ebx
      invoke SendMessage,hWnd,LB_RESETCONTENT,0,0
      invoke SendMessage,hWnd,LB_ADDSTRING,0,offset _z    ; 0
      invoke wsprintf,addr buf,offset _2,count_qs,0,0
      invoke SendMessage,hWnd,LB_ADDSTRING,0,addr buf     ; 1
      invoke wsprintf,addr buf,offset _8,count_sys,0,0,0,0
      invoke SendMessage,hWnd,LB_ADDSTRING,0,addr buf     ; 2
      invoke wsprintf,addr buf,offset _7,count_key,0,0
      invoke SendMessage,hWnd,LB_ADDSTRING,0,addr buf     ; 3      
      invoke wsprintf,addr buf,offset _6,count_clk,0,0,0
      invoke SendMessage,hWnd,LB_ADDSTRING,0,addr buf     ; 4
      invoke SendMessage,hWnd,LB_ADDSTRING,0,offset _z    ; 5
      invoke SendMessage,hWnd,LB_SETITEMDATA,5,edi      
      invoke SendMessage,hWnd,LB_ADDSTRING,0,offset _head ; 6
      invoke SendMessage,hWnd,LB_SETITEMDATA,6,ebx
      invoke SendMessage,hWnd,LB_ADDSTRING,0,offset _z    ; 7
      invoke SendMessage,hWnd,LB_SETITEMDATA,7,esi
      mov eax,hWnd
      jmp @@@

    .elseif wParam==id+2  ; (Repair)
      invoke SendMessage,hWnd,LB_GETCOUNT,0,0
      mov ebx,eax
      mov edi,8
      .while edi<ebx
        invoke SendMessage,hWnd,LB_GETITEMDATA,edi,0
        mov esi,eax
        invoke SendMessage,hWnd,LB_GETTEXT,edi,addr buff
        invoke lstrcpy,addr buf,addr buff+59
        mov byte ptr [buff+22],0
        invoke IsWindow,esi
        .if eax!=0
          invoke GetAncestor,esi,GA_PARENT
          push eax
          invoke GetWindow,esi,GW_OWNER
          push eax
          invoke GetWindowLong,esi,GWL_ID
          and eax,0ffffh
          pop edx
          pop ecx          
          invoke wsprintf,addr bu,offset _XXXX,ecx,edx,esi,eax
          lea ecx,bu
        .else
          mov ecx,offset _isnt
        .endif
        invoke wsprintf,addr buffe,offset _rep,addr buff,ecx,addr buf
        invoke SendMessage,hWnd,LB_DELETESTRING,edi,0
        invoke SendMessage,hWnd,LB_INSERTSTRING,edi,addr buffe
        invoke SendMessage,hWnd,LB_SETITEMDATA,edi,esi
        inc edi
      .endw

    .elseif wParam==id+7  ; (OnTop/NonTop)
      invoke SendMessage,hWnd,LB_GETITEMDATA,0,0
      mov esi,eax
      invoke IsWindow,esi
      .if eax!=0
        invoke GetWindowLong,esi,GWL_EXSTYLE
        and eax,WS_EX_TOPMOST
        .if eax==0
          mov eax,HWND_TOPMOST
          mov ebx,offset _nontop
        .else
          mov eax,HWND_NOTOPMOST
          mov ebx,offset _ontop
        .endif
        invoke SetWindowPos,esi,eax,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE or SWP_FRAMECHANGED
        jmp @f
      .endif
      xor eax,eax

    .elseif wParam==id+3  ; (HOOK/UnHOOK)
      xor hookflag,1
      .if hookflag!=0
        invoke InstallHook,hWnd
        mov ebx,offset _unhook        
      .else
        invoke UninstallHook
        mov ebx,offset _hook        
      .endif
      jmp @f

    .elseif wParam==id+4  ; ([send]/[post]/[send+delay])
      mov ebx,postparam
      inc ebx
      .if ebx>2
        xor ebx,ebx
      .endif
      mov postparam,ebx      
      invoke SetHookParam,ebx
      .if ebx==0
        mov ebx,offset _send
      .elseif ebx==1
        mov ebx,offset  _post
      .else
        mov ebx,offset _senddl
      .endif
@@:
      invoke GetMenu,hWnd
      invoke ModifyMenu,eax,wParam,MF_BYCOMMAND or MF_STRING,wParam,ebx
      invoke SetWindowPos,hWnd,0,0,0,0,0,SWP_NOZORDER OR SWP_NOMOVE OR SWP_NOSIZE OR SWP_FRAMECHANGED

    .elseif wParam==id+5  ; (Minimize)
      mov edi,SW_MINIMIZE
      jmp @f
      
    .elseif wParam==id+6  ; (Restore)
      mov edi,SW_RESTORE
@@:
      invoke SendMessage,hWnd,LB_GETITEMDATA,0,0
      mov ebx,eax
      invoke IsWindow,ebx
      .if eax!=0
        invoke ShowWindow,ebx,edi
      .endif

    .else
      jmp @f
    .endif
    xor eax,eax
;------------------------------------------------------------------------------------------
  .elseif eax==WM_MOUSEWHEEL
  
    mov eax,lParam
    mov ecx,eax
    and eax,0ffffh
    shr ecx,16
    invoke WindowFromPoint,eax,ecx
    jmp @@@
;------------------------------------------------------------------------------------------
  .elseif eax==WM_LBUTTONDOWN || eax==WM_RBUTTONDOWN
  
    invoke SendMessage,hWnd,LB_ITEMFROMPOINT,0,lParam
    mov edi,eax
    invoke SendMessage,hWnd,LB_GETITEMDATA,edi,0
@@@:
    mov ebx,eax
    invoke SendMessage,hWnd,LB_DELETESTRING,0,0
    invoke GetClassName,ebx,addr buf,127
    invoke wsprintf,addr buffe,offset _Xs,ebx,addr buf
    invoke SendMessage,hWnd,LB_INSERTSTRING,0,addr buffe
    invoke SendMessage,hWnd,LB_SETITEMDATA,0,ebx
    .if uMsg==WM_RBUTTONDOWN
      invoke SendMessage,hWnd,LB_GETSEL,edi,0
      .if eax==0
        inc eax
      .else
        xor eax,eax
      .endif
      invoke SendMessage,hWnd,LB_SETSEL,eax,edi
      invoke MessageBeep,0
      invoke IsWindow,ebx
      .if eax==0
        invoke Sleep,200
        invoke MessageBeep,0
        invoke SendMessage,hWnd,LB_SETSEL,0,edi
      .endif
    .endif
    jmp @f
;------------------------------------------------------------------------------------------    
  .else
@@:
    invoke GetWindowLong,hWnd,GWL_USERDATA
    invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
  .endif
  ret
WndProc endp

;##########################################################################################

MessageLoop proc
  local msg:MSG
  .while TRUE
    invoke GetMessage,addr msg,0,0,0
    .break .if (!eax)
    invoke TranslateMessage,addr msg
    invoke DispatchMessage,addr msg
  .endw
  mov	eax,msg.wParam
  ret
MessageLoop endp

;##########################################################################################

start:
  invoke GetModuleHandle,0
  mov hinst,eax
  invoke LoadMenu,eax,id
  invoke CreateWindowEx,WS_EX_DLGMODALFRAME or WS_EX_CLIENTEDGE,offset _listbox,offset _app,WS_VISIBLE or WS_OVERLAPPEDWINDOW or WS_VSCROLL or LBS_HASSTRINGS or LBS_MULTIPLESEL,0,0,680,400,0,eax,hinst,0
  push ebx
  mov ebx,eax
  invoke SetWindowLong,ebx,GWL_WNDPROC,offset WndProc
  invoke SetWindowLong,ebx,GWL_USERDATA,eax
  invoke CreateFontIndirect,offset _logfont
  push eax
  invoke SendMessage,ebx,WM_SETFONT,eax,1
  invoke SendMessage,ebx,WM_COMMAND,id+1,0
  invoke MessageLoop
  call DeleteObject
  call ExitProcess
  invoke InitCommonControls
end start

;##########################################################################################

