
.386
.model flat,stdcall
option casemap:none

; ml   /I\masm32\include ...
; link /libpath:\masm32\lib /dll /def:%name%.def /section:.bss,S ...

inclib macro x
 include x.inc
 includelib x.lib
endm

include windows.inc
inclib user32
inclib kernel32

.data
 hinst  dd 0

.data?
 hhook  dd ?
 hwnd   dd ?
 param dd ?

.code

DllEntry proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD
  .if reason==DLL_PROCESS_ATTACH
    mov eax,hInst
    mov hinst,eax
  .endif
  mov eax,TRUE
  ret
DllEntry Endp

HookProc proc uses ebx edi esi nCode:UINT, wParam:WPARAM, lParam:LPARAM
  mov esi,wParam
;  .if nCode==HCBT_DESTROYWND || nCode==HCBT_CREATEWND || nCode==HCBT_ACTIVATE || nCode==HCBT_SETFOCUS || nCode==HCBT_MINMAX || nCode==HCBT_MOVESIZE
  .if nCode==HCBT_CREATEWND
    invoke GetAncestor,wParam,GA_PARENT
    mov ebx,eax
    jmp @f
  .elseif nCode==HCBT_ACTIVATE
    mov eax,lParam
    mov ebx,dword ptr [eax+4]   ; CBTACTIVATESTRUCT.hWndActive
    jmp @f
  .elseif nCode==HCBT_CLICKSKIPPED
    mov eax,lParam
    mov ebx,dword ptr [eax+4*2] ; MOUSEHOOKSTRUCT.hwnd
    mov ecx,dword ptr [eax+4*3] ; MOUSEHOOKSTRUCT.wHitTestCode
    shl ecx,16
    and esi,0ffffh
    or esi,ecx
    jmp @f
  .else
    mov ebx,lParam
@@:
    mov edi,WM_APP
    add edi,nCode
    .if param==0
@@:
      invoke SendMessageTimeout,hwnd,edi,esi,ebx,SMTO_ABORTIFHUNG,300,0
    .elseif param==1
      invoke PostMessage,hwnd,edi,esi,ebx
    .else
      invoke Sleep,500
      jmp @b
    .endif
  .endif
  invoke CallNextHookEx,hhook,nCode,wParam,lParam
  ret
HookProc endp

InstallHook proc hWnd:DWORD
  mov eax,hWnd
  mov hwnd,eax
  .if hhook==0
    invoke SetWindowsHookEx,WH_CBT,addr HookProc,hinst,0
    mov hhook,eax
  .endif
	ret 
InstallHook endp

UninstallHook proc
  .if hhook!=0
	  invoke UnhookWindowsHookEx,hhook
	  .if eax!=0
	    xor ecx,ecx
	    mov hhook,ecx
	  .endif
	.endif
	ret
UninstallHook endp

SetHookParam proc lParam:LPARAM
  mov eax,lParam
  mov param,eax
  ret
SetHookParam endp

End DllEntry
